diff --git a/src/rrd2json.c b/src/rrd2json.c
index 34e1535dd582d..fb658b3adbf86 100644
--- a/src/rrd2json.c
+++ b/src/rrd2json.c
@@ -124,20 +124,42 @@ void rrd_stats_api_v1_charts(BUFFER *wb)
     );
 }
 
+static inline size_t prometheus_name_copy(char *d, const char *s, size_t usable) {
+    size_t n;
+
+    for(n = 0; *s && n < usable ; d++, s++, n++) {
+        register char c = *s;
+
+        if(unlikely(!isalpha(c) && !isdigit(c))) *d = '_';
+        else *d = c;
+    }
+    *d = '\0';
+
+    return n;
+}
+
+#define PROMETHEUS_ELEMENT_MAX 256
+
 void rrd_stats_api_v1_charts_allmetrics_prometheus(BUFFER *wb)
 {
     pthread_rwlock_rdlock(&localhost.rrdset_root_rwlock);
 
+    char host[PROMETHEUS_ELEMENT_MAX + 1];
+    prometheus_name_copy(host, config_get("global", "hostname", "localhost"), PROMETHEUS_ELEMENT_MAX);
+
     // for each chart
     RRDSET *st;
     for(st = localhost.rrdset_root; st ; st = st->next) {
+        char chart[PROMETHEUS_ELEMENT_MAX + 1];
+        prometheus_name_copy(chart, st->id, PROMETHEUS_ELEMENT_MAX);
+
         buffer_strcat(wb, "\n");
         if(st->enabled && st->dimensions) {
             // for each dimension
             RRDDIM *rd;
             for(rd = st->dimensions; rd ; rd = rd->next) {
                 if(rd->counter) {
-                    buffer_sprintf(wb, "# HELP %s.%s %s\n", st->id, rd->id, st->units);
+                    // buffer_sprintf(wb, "# HELP %s.%s %s\n", st->id, rd->id, st->units);
 
                     switch(rd->algorithm) {
                         case RRDDIM_INCREMENTAL:
@@ -150,9 +172,15 @@ void rrd_stats_api_v1_charts_allmetrics_prometheus(BUFFER *wb)
                             break;
                     }
 
-                    calculated_number n = (calculated_number)rd->last_collected_value * (calculated_number)(abs(rd->multiplier)) / (calculated_number)(abs(rd->divisor));
+                    // calculated_number n = (calculated_number)rd->last_collected_value * (calculated_number)(abs(rd->multiplier)) / (calculated_number)(abs(rd->divisor));
+                    // buffer_sprintf(wb, "%s.%s " CALCULATED_NUMBER_FORMAT " %llu\n", st->id, rd->id, n,
+                    //        (unsigned long long)((rd->last_collected_time.tv_sec * 1000) + (rd->last_collected_time.tv_usec / 1000)));
+
+                    char dimension[PROMETHEUS_ELEMENT_MAX + 1];
+                    prometheus_name_copy(dimension, rd->id, PROMETHEUS_ELEMENT_MAX);
 
-                    buffer_sprintf(wb, "%s.%s " CALCULATED_NUMBER_FORMAT " %llu\n", st->id, rd->id, n,
+                    buffer_sprintf(wb, "%s.%s{instance=\"%s\"} " COLLECTED_NUMBER_FORMAT " %llu\n",
+                            chart, dimension, host, rd->last_collected_value,
                             (unsigned long long)((rd->last_collected_time.tv_sec * 1000) + (rd->last_collected_time.tv_usec / 1000)));
                 }
             }
diff --git a/src/rrd2json.h b/src/rrd2json.h
index 7a34b15051aee..d2982e6670440 100644
--- a/src/rrd2json.h
+++ b/src/rrd2json.h
@@ -2,7 +2,6 @@
 #define NETDATA_RRD2JSON_H 1
 
 #define HOSTNAME_MAX 1024
-extern char *hostname;
 
 #define API_RELATIVE_TIME_MAX (3 * 365 * 86400)
 
diff --git a/src/web_buffer.h b/src/web_buffer.h
index 4c2d599996ab9..14d16f3f60e13 100644
--- a/src/web_buffer.h
+++ b/src/web_buffer.h
@@ -39,6 +39,7 @@ typedef struct web_buffer {
 #define CT_IMAGE_XICON                  19
 #define CT_IMAGE_ICNS                   20
 #define CT_IMAGE_BMP                    21
+#define CT_PROMETHEUS                   22
 
 #define buffer_cacheable(wb)    do { (wb)->options |= WB_CONTENT_CACHEABLE;    if((wb)->options & WB_CONTENT_NO_CACHEABLE) (wb)->options &= ~WB_CONTENT_NO_CACHEABLE; } while(0)
 #define buffer_no_cacheable(wb) do { (wb)->options |= WB_CONTENT_NO_CACHEABLE; if((wb)->options & WB_CONTENT_CACHEABLE)    (wb)->options &= ~WB_CONTENT_CACHEABLE;  (wb)->expires = 0; } while(0)
diff --git a/src/web_client.c b/src/web_client.c
index 161f7a08370c9..5915ed6cc3d2c 100644
--- a/src/web_client.c
+++ b/src/web_client.c
@@ -796,7 +796,6 @@ int web_client_api_request_v1_allmetrics(struct web_client *w, char *url)
 
     buffer_flush(w->response.data);
     buffer_no_cacheable(w->response.data);
-    w->response.data->contenttype = CT_TEXT_PLAIN;
 
     switch(format) {
         //case RAWMETRICS_BASH:
@@ -804,10 +803,12 @@ int web_client_api_request_v1_allmetrics(struct web_client *w, char *url)
         //    return 200;
 
         case RAWMETRICS_PROMETHEUS:
+            w->response.data->contenttype = CT_PROMETHEUS;
             rrd_stats_api_v1_charts_allmetrics_prometheus(w->response.data);
             return 200;
 
         default:
+            w->response.data->contenttype = CT_TEXT_PLAIN;
             buffer_strcat(w->response.data, "Which format? Only '" RAWMETRICS_FORMAT_PROMETHEUS "' is currently supported.");
             return 400;
     }
@@ -1734,6 +1735,9 @@ const char *web_content_type_to_string(uint8_t contenttype) {
         case CT_IMAGE_ICNS:
             return "image/icns";
 
+        case CT_PROMETHEUS:
+            return "text/plain; version=0.0.4";
+
         default:
         case CT_TEXT_PLAIN:
             return "text/plain; charset=utf-8";
